 
#define stp 2 //easy motor driver connections 
#define dir 3
#define EN 4
#define stp2 5
#define dir2 6
#define EN2 7
#define rubberstmp  10 //connected to relay -> solenoid
#define limitswitch 11 //to extreme left

char Data; //bluetooth data
int x;
int y;
int t;
int m;
int s;
int step01 = 200;
int step02 = 100;
int centerpos = 900; //frm 0 to right
int padpos = 400; //frm o to right
int paperpos = 900; //frm pad to paper
int origin = 0; 
int stampmulti = 0;//multiple time stamps
int countsteps;
int scrollpages = 250; //rotations to scroll page
int scrollpage = 150; //scroll page little

//    ...             pad             | C |                      pap           ...      //
//900 800 700 600 500 400 300 200 100 | 0 | +100 +200 +300 +400 +500 +600 +700 +800 +900//
//000 100 200 300 400 500 600 700 800 |900| 1000 1100 1200 1300 1400 1500 1600 1700 1800//

 
void setup() {
  Serial.begin(9600);

  pinMode(stp, OUTPUT);
  pinMode(dir, OUTPUT);
  pinMode(EN, OUTPUT); //motor driver 1
  pinMode(stp2, OUTPUT);
  pinMode(dir2, OUTPUT);
  pinMode(EN2, OUTPUT); //motor driver 2
  pinMode (rubberstmp, OUTPUT);
  pinMode (limitswitch, INPUT_PULLUP);
  digitalWrite(rubberstmp, HIGH); //active low mechanism
  stopstepper(); 
}


void loop() {

  if (Serial.available())
  {
  
    Data=Serial.read(); 
  
    if(Data=='q')
    {  
    moveleft();
    }
    if(Data=='w')
    {  
    moveright();
    }
    if(Data=='Q')
    {  
    moveleft2();
    }
    if(Data=='W')
    {  
    moveright2();
    }
    if(Data=='s')
    { 
     stamp();
    }
    if(Data=='h')
    { 
    homing();
    }
    if(Data=='p')
    { 
      //homing();//go to zero
      if (origin==0)
      {
    movetopad();
    delay(1000);
    stamp(); 
      }
      if(origin==1)
      {
        papertopad();
        delay(1000);
        stamp();
      }
    }
    if(Data=='P')
    { 
    movetopaper();
    delay(1000);
    stamp();
    origin=1;
    }
    if(Data=='m')
    { 
    stampmultiple();
    }
    if(Data=='c')
    { 
    Serial.print("stepper at ");
    Serial.println(countsteps);
    }
    /*if (Data >= 1) 
    {
      //if (Data <= 9)
      //{
       stampmulti = Data -48;
      Serial.println(stampmulti);
      stampmultiple();
      //}
    }*/
    if(Data=='a')
    { 
    stampmulti = 2;
    }
    if(Data=='A')
    { 
    stampmulti = 3;
    }
    if(Data=='b')
    { 
    stampmulti = 4;
    }
    if(Data=='B')
    { 
    stampmulti = 5;
    }
    if(Data=='l')
    { 
    //pagedown();
    pageup();
    }
    if(Data=='k')
    { 
    pagedown();
    //pageup();
    }
    if(Data=='L')
    { 
    pageups();
    
    }
    if(Data=='K')
    { 
    pagedowns();
    
    } 
     


  stopstepper();
  }
delay(10);

}



void stopstepper()
{
  digitalWrite(stp, LOW);
  digitalWrite(dir, LOW);
  digitalWrite(EN, HIGH);
  digitalWrite(stp2, LOW);
  digitalWrite(dir2, LOW);
  digitalWrite(EN2, HIGH);
}


void moveleft()
{
  Serial.print("Moving left -");
  Serial.println(step01);
   digitalWrite(EN, LOW);
  digitalWrite(dir, HIGH); //left
  for(x= 1; x< step01; x++)  
  {
    digitalWrite(stp,HIGH); 
    delay(1);
    digitalWrite(stp,LOW); 
    delay(1);
  }
  countsteps= countsteps - step01;
}


void moveright()
{
  Serial.print("Moving right ");
  Serial.println(step01);
  digitalWrite(EN, LOW);
  digitalWrite(dir, LOW); //right
  for(x= 1; x< step01; x++)  
  {
    digitalWrite(stp,HIGH); 
    delay(1);
    digitalWrite(stp,LOW); 
    delay(1);
  }
  countsteps= countsteps + step01;
}

void moveleft2()
{
  Serial.print("Moving left -");
  Serial.println(step02);
   digitalWrite(EN, LOW);
  digitalWrite(dir, HIGH); //left
  for(x= 1; x< step02; x++)  
  {
    digitalWrite(stp,HIGH); 
    delay(1);
    digitalWrite(stp,LOW); 
    delay(1);
  }
  countsteps= countsteps - step02;
}

void moveright2()
{
  Serial.print("Moving right ");
  Serial.println(step02);
   digitalWrite(EN, LOW);
  digitalWrite(dir, LOW); //right
  for(x= 1; x< step02; x++)  
  {
    digitalWrite(stp,HIGH); 
    delay(1);
    digitalWrite(stp,LOW); 
    delay(1);
  }
  countsteps= countsteps + step02;
}

void stamp()
   { 
       digitalWrite(rubberstmp, LOW);
       Serial.println("solenoid engage");
       delay(1000);
       digitalWrite(rubberstmp, HIGH);
       Serial.println("solenoid disengage");
    }
    
/*void movetocenter()
{
  Serial.print("Moving to center ");
  Serial.println(centerpos);
   digitalWrite(EN, LOW);
  digitalWrite(dir, HIGH); //right
  for(x= 1; x< centerpos; x++)  
  {
    digitalWrite(stp,HIGH); 
    delay(1);
    digitalWrite(stp,LOW); 
    delay(1);
  }
  
}*/

void movetopad()
{
  Serial.print("Moving to inkpad ");
  Serial.println(padpos);
   digitalWrite(EN, LOW);
  digitalWrite(dir, LOW); //right
  for(x= 1; x< padpos; x++)  
  {
    digitalWrite(stp,HIGH); 
    delay(1);
    digitalWrite(stp,LOW); 
    delay(1);
  }
  countsteps= countsteps + padpos;
}

void movetopaper()
{
  Serial.print("Moving to paper ");
  Serial.println(paperpos);
   digitalWrite(EN, LOW);
  digitalWrite(dir, LOW); //right
  for(y= 1; y< paperpos; y++)  
  {
    digitalWrite(stp,HIGH); 
    delay(1);
    digitalWrite(stp,LOW); 
    delay(1);
  }
 //countsteps= countsteps + paperpos; 
}

void papertopad()
{
  Serial.print("Moving paper to pad -");
  Serial.println(paperpos);
   digitalWrite(EN, LOW);
  digitalWrite(dir, HIGH); //left
  for(t= 1; t< paperpos; t++)  
  {
    digitalWrite(stp,HIGH); 
    delay(1);
    digitalWrite(stp,LOW); 
    delay(1);
  }
  //countsteps= countsteps - paperpos;
}

void stampmultiple()
{
  Serial.print("stamping multiple times = ");
  Serial.println(stampmulti);
  homing(); //starting from zero
    delay(500); 
        movetopad();
    delay(1000);
       pageups();
    delay(1000); 
  //digitalWrite(EN, LOW);
  for(m= 1; m<= stampmulti; m++)  
  {
    stamp();
    delay(1000);
    movetopaper();
    delay(1000);
     pageup();
    delay(3000);
    stamp();
    delay(1000);
   
    papertopad();
    delay(1000);
    Serial.print("completed = ");
    Serial.println(m);
  }
 
  Serial.print("Stamping completed ");
  Serial.print(stampmulti);
  Serial.println(" times");
   homing(); //go to zero
}

void homing()
{
  Serial.println("Homing...");
  while (digitalRead(limitswitch))
  {  
    digitalWrite(EN, LOW);
    digitalWrite(dir, HIGH); //left
    digitalWrite(stp,HIGH); 
    delay(2);
    digitalWrite(stp,LOW); 
    delay(2);     
  }    
  delay(1000);
  while (!digitalRead(limitswitch)) 
  {
    digitalWrite(EN, LOW);
    digitalWrite(dir, LOW); //right
    digitalWrite(stp,HIGH); 
    delay(1);
    digitalWrite(stp,LOW); 
    delay(1);
  }
  origin=0;
  countsteps=0;
 Serial.println("Homing complete");
}    

void pageup()
{
  Serial.print("scrolling page up");
  Serial.println(scrollpage);
   digitalWrite(EN2, LOW);
  digitalWrite(dir2, LOW); //left
  for(s= 1; s< scrollpage; s++)  
  {
    digitalWrite(stp2,HIGH); 
    delay(1);
    digitalWrite(stp2,LOW); 
    delay(1);
  }
  Serial.print("scrolling complete");
}

void pagedown()
{
  Serial.print("scrolling page down");
  Serial.println(scrollpage);
   digitalWrite(EN2, LOW);
  digitalWrite(dir2, HIGH); //right
  for(s= 1; s< scrollpage; s++)  
  {
    digitalWrite(stp2,HIGH); 
    delay(1);
    digitalWrite(stp2,LOW); 
    delay(1);
  }
  Serial.print("scrolling complete");
}                             

 void pagedowns()
 {
  Serial.print("scrolling page down");
  Serial.println(scrollpages);
   digitalWrite(EN2, LOW);
  digitalWrite(dir2, HIGH); //right
  for(s= 1; s< scrollpages; s++)  
  {
    digitalWrite(stp2,HIGH); 
    delay(1);
    digitalWrite(stp2,LOW); 
    delay(1);
  }
  Serial.print("scrolling complete");
} 

void pageups()
 {
  Serial.print("scrolling page down");
  Serial.println(scrollpages);
   digitalWrite(EN2, LOW);
  digitalWrite(dir2, LOW); //left
  for(s= 1; s< scrollpages; s++)  
  {
    digitalWrite(stp2,HIGH); 
    delay(1);
    digitalWrite(stp2,LOW); 
    delay(1);
  }
  Serial.print("scrolling complete");
} 
 
